require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_ARM_ATOMIC_H_)) {
    eval 'sub _ARM_ATOMIC_H_ () {1;}' unless defined(&_ARM_ATOMIC_H_);
    if(defined(&_KERNEL)) {
	require 'arm/cpufunc.ph';
	require 'arm/armreg.ph';
	eval 'sub atomic_cas_uint {
	    my($_p, $_o, $_n) = @_;
    	    eval q( &_atomic_cas_uint(($_p), ($_o), ($_n)));
	}' unless defined(&atomic_cas_uint);
	eval 'sub atomic_cas_ulong {
	    my($_p, $_o, $_n) = @_;
    	    eval q( &_atomic_cas_ulong(($_p), ($_o), ($_n)));
	}' unless defined(&atomic_cas_ulong);
	eval 'sub atomic_cas_ptr {
	    my($_p, $_o, $_n) = @_;
    	    eval q( &_atomic_cas_ptr(($_p), ($_o), ($_n)));
	}' unless defined(&atomic_cas_ptr);
	eval 'sub atomic_swap_uint {
	    my($_p, $_n) = @_;
    	    eval q( &_atomic_swap_uint(($_p), ($_n)));
	}' unless defined(&atomic_swap_uint);
	eval 'sub atomic_swap_ulong {
	    my($_p, $_n) = @_;
    	    eval q( &_atomic_swap_ulong(($_p), ($_n)));
	}' unless defined(&atomic_swap_ulong);
	eval 'sub atomic_swap_ptr {
	    my($_p, $_n) = @_;
    	    eval q( &_atomic_swap_ptr(($_p), ($_n)));
	}' unless defined(&atomic_swap_ptr);
	eval 'sub atomic_add_int_nv {
	    my($_p, $_v) = @_;
    	    eval q( &_atomic_add_int_nv(($_p), ($_v)));
	}' unless defined(&atomic_add_int_nv);
	eval 'sub atomic_add_long_nv {
	    my($_p, $_v) = @_;
    	    eval q( &_atomic_add_long_nv(($_p), ($_v)));
	}' unless defined(&atomic_add_long_nv);
	eval 'sub atomic_sub_int_nv {
	    my($_p, $_v) = @_;
    	    eval q( &_atomic_sub_int_nv(($_p), ($_v)));
	}' unless defined(&atomic_sub_int_nv);
	eval 'sub atomic_sub_long_nv {
	    my($_p, $_v) = @_;
    	    eval q( &_atomic_sub_long_nv(($_p), ($_v)));
	}' unless defined(&atomic_sub_long_nv);
	if(defined(&CPU_ARMv7)) {
	    eval 'sub __membar {
	        my($_f) = @_;
    		eval q( &do {  &__asm  &__volatile($_f ::: \\"memory\\"); }  &while (0));
	    }' unless defined(&__membar);
	    eval 'sub membar_enter () {
	        eval q( &__membar(\\"dmb sy\\"));
	    }' unless defined(&membar_enter);
	    eval 'sub membar_exit () {
	        eval q( &__membar(\\"dmb sy\\"));
	    }' unless defined(&membar_exit);
	    eval 'sub membar_producer () {
	        eval q( &__membar(\\"dmb st\\"));
	    }' unless defined(&membar_producer);
	    eval 'sub membar_consumer () {
	        eval q( &__membar(\\"dmb sy\\"));
	    }' unless defined(&membar_consumer);
	    eval 'sub membar_sync () {
	        eval q( &__membar(\\"dmb sy\\"));
	    }' unless defined(&membar_sync);
	    eval 'sub virtio_membar_producer () {
	        eval q( &__membar(\\"dmb st\\"));
	    }' unless defined(&virtio_membar_producer);
	    eval 'sub virtio_membar_consumer () {
	        eval q( &__membar(\\"dmb sy\\"));
	    }' unless defined(&virtio_membar_consumer);
	    eval 'sub virtio_membar_sync () {
	        eval q( &__membar(\\"dmb sy\\"));
	    }' unless defined(&virtio_membar_sync);
	}
    }
}
1;
